-- EuOS Kernel version 1.5 by Jeffrey Fielding
-- To prevent namespace problems, all kernel routines
-- and variables start with k_, and all constants with K_
with trace
without warning
-- Core kernel modules
include tasks.e -- Multitasking / multithreading
include ipc.e   -- Interprocess communications
include fs.e    -- File systems

include rootfs.e   -- Root filesystem
include devfs.e    -- /dev filesystem
include drivers.e  -- drivers to go under /dev
global function k_exec(sequence a, sequence b)
	integer f, pid, junk
	object x
	b = {a} & b
	f = k_open(a,"r")
	if f = -1 then
		return -1
	end if
	x = k_read(f,1)
	if integer(x) then
		return -2
	end if
	junk = k_close(f)
	pid = k_newTask(x[1])
	k_setCommandLine(pid, b)
	return pid
end function
include programs.e -- Programs

-- The initialization function
-- this is the first task to run, after drivers, etc.
include get.e

function initFunction()
	if k_exec("/bin/init",{}) <= 0 then
		puts(1,"Kernel panic: can't run /bin/init!\n")
	end if
	return -1
end function
integer initpid
initpid = k_newTask(routine_id("initFunction"))
k_startMultitasking()

